using TestCustomComponents.Models;

namespace TestCustomComponents
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Log(string message)
        {
            richTextBox1.Text = $"{richTextBox1.Text}\n{message}";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            customListBox1.AnErrorOccurred += ex => Log(ex.Message);
            customListBox1.ValueChanged += (obj, sender) => Log($"Selected1 is {customListBox1.Selected}");
            customNumericInputField1.AnErrorOccurred += ex => Log(ex.Message);
            customNumericInputField1.NumericInputChanged += (obj, sender) => Log("Test 4 ok");

            customListBox1.FillValues(["hello", "world", "123", "321"]);

            customListBox1.Selected = "123";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            customListBox1.Clear();
            customListBox1.Selected = "234";
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Log($"Selected2 is {customNumericInputField1.Value?.ToString() ?? "null"}");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            richTextBox1.Clear();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            customNumericInputField1.Value = 3333;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            customNumericInputField1.Value = null;
        }

        private void button7_Click(object sender, EventArgs e)
        {
            customDataTable1.ConfigureColumns(
                new()
                {
                    HeaderName = "Id",
                    PropertyName = nameof(TestModel.Id),
                    Visible = false,
                },
                new()
                {
                    HeaderName = "Name",
                    PropertyName = nameof(TestModel.Name),
                    Width = 100,
                },
                new()
                {
                    HeaderName = "Age",
                    PropertyName = nameof(TestModel.Age),
                }
                );
        }

        private void button8_Click(object sender, EventArgs e)
        {
            customDataTable1.Fill<TestModel>([
                new(){
                    Id = 1,
                    Name = "Vasya",
                    Age = 5,
                },
                new()
                {
                    Id = 2,
                    Name = "Vilthare",
                    Age = 3,
                },
                new()
                {
                    Id = 3,
                    Name = "MOMO",
                    Age = 10,
                },
                ]);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            customDataTable1.Clear();
        }

        private void button10_Click(object sender, EventArgs e)
        {
            Log($"selected3 {customDataTable1.SelectedRow}");
        }

        private void button11_Click(object sender, EventArgs e)
        {
            customDataTable1.SelectedRow = customNumericInputField1.Value!.Value;
        }

        private void button12_Click(object sender, EventArgs e)
        {
            var elem = customDataTable1.GetRow<TestModel>(customDataTable1.SelectedRow)!;
            Log($"Selected: id={elem.Id} name={elem.Name} age={elem.Age}");
        }
    }
}
